Program ListaReverse;

type	puntacella = ^cella;
	cella = record
		precedente : puntacella;
		valore : integer;
		successivo : puntacella
	end;

var	pattivo, testa, coda : puntacella;
	numero : integer;

Procedure Inserisci();
Begin
	numero := 0;
	pattivo := NIL;
	testa := NIL;

	(* continua a chiedere l'inserimento fino a quando non si
		indica un valore negativo *)
	while numero>=0 do
	Begin
		Write('Numero da inserire: ');
		Readln(numero);
		
		if (numero >= 0) then 
		Begin
			(* lista vuota *)
			if pattivo=NIL then
			Begin
				new(pattivo);
				pattivo^.precedente:=NIL;
				pattivo^.valore:=numero;
				pattivo^.successivo:=NIL;
				testa:=pattivo
			End else (* lista non vuota *)
			Begin
				new(pattivo^.successivo);
				pattivo^.successivo^.precedente:=pattivo;
				pattivo^.successivo^.valore:=numero;
				pattivo^.successivo^.successivo:=NIL;
				pattivo:=pattivo^.successivo
			End
		End else	coda:=pattivo
	End
End;

(* visita inversa della lista *)
Procedure Visita();

Begin
	while coda<>NIL do
	Begin
		writeln(coda^.valore);
		coda:=coda^.precedente
	End

End;

Begin
	Inserisci();
	Visita()
End.

